Download it now!
Bug 122218 - After Update to 6.1.4 on macOS fonts are blurred on retina display (xcode 10)
Summary: After Update to 6.1.4 on macOS fonts are blurred on retina display (xcode 10)
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
6.1.4.2 release
Hardware: All Mac OS X (All)
: highest critical
Assignee: Stephan Bergmann
URL:
Whiteboard: target:7.0.0 target:6.4.2
Keywords: bibisectNotNeeded, regression
: 125915 126775 126841 126907 126947 126950 126982 127020 127023 127084 127177 128118 128636 128936 129272 129562 129727 129941 130889 132382 (view as bug list)
Depends on:
Blocks: MacOS-Wishlist HiDPI
  Show dependency treegraph
 
Reported: 2018-12-20 10:37 UTC by thdeppner
Modified: 2020-05-02 19:50 UTC (History)
69 users (show)

See Also:
Crash report or crash signature:


Attachments
Writer (969.02 KB, image/png)
2018-12-20 11:29 UTC, Maciej Tarmas
Details
Calc (1.04 MB, image/png)
2018-12-20 11:30 UTC, Maciej Tarmas
Details
Writer with Liberation Serif (699.98 KB, image/png)
2018-12-24 20:37 UTC, Maciej Tarmas
Details
LO5472 screenshot font display (83.85 KB, image/png)
2018-12-26 08:58 UTC, Alex Thurgood
Details
LO6412 screenshot font display (134.40 KB, image/png)
2018-12-26 08:59 UTC, Alex Thurgood
Details
Screenshot of Calc LO6.3.0.1 (25.57 KB, image/png)
2019-07-17 08:48 UTC, trainman75
Details
Comparison 6.3.2.0.0+ and 6.3.0.4 (47.90 KB, image/png)
2019-08-23 13:36 UTC, trainman75
Details
Calc after enabling "low resolution" in .app configuration (79.05 KB, image/png)
2019-09-19 16:01 UTC, Wojtek
Details
Calc default display *WITHOUT* enabling "low resolution" in .app configuration (65.44 KB, image/png)
2019-09-19 16:02 UTC, Wojtek
Details
Fuzzy: Open Office vs Libre Office (38.32 KB, image/jpeg)
2019-10-29 10:30 UTC, Mike Newman
Details
Writer with Liberation Serif, recreated w 6.5 for comparison (279.76 KB, image/png)
2019-12-18 12:34 UTC, steve -_-
Details
Screenshot of LO BASE form, design mode OFF (20.00 KB, image/png)
2019-12-19 10:10 UTC, work
Details
Screenshot of LO BASE form, design mode ON (38.88 KB, image/png)
2019-12-19 10:11 UTC, work
Details
Screenshot of LO BASE main window (125.78 KB, image/png)
2019-12-19 10:21 UTC, work
Details
Comparison of 6.2.8.2 and 6.4.0.1 on MacBook Pro 2014. (120.44 KB, image/jpeg)
2019-12-23 23:47 UTC, Roger Paradise
Details
Comparison of 6.1.6.3 and 6.5.0.0 2019-12-30 build (400%) (90.26 KB, text/plain)
2019-12-31 11:40 UTC, Chris Shaw
Details
Comparison of 6.1.6.3 and 6.5.0.0 2019-12-30 build (400% - Macbook Air 2018) (133.65 KB, image/png)
2019-12-31 11:44 UTC, Chris Shaw
Details
LO Vanilla 6.2.6.2 vs 6.5 Nighly (734.09 KB, image/png)
2020-01-28 20:17 UTC, eisa01
Details
Fuzzy display on 2019 iMac 5K (Retina Display), macOS 10.15.3, LO 6.4.0.3 (2.19 MB, image/png)
2020-01-31 22:05 UTC, brettjralton
Details
Drop down list first item sharp and the rest is blurry (70.98 KB, image/png)
2020-02-06 02:28 UTC, G
Details
Row 8 has text previously writen and Row 9 is being edited/selected (8.88 KB, image/png)
2020-02-06 02:30 UTC, G
Details
Blurry text on About LibreOffice (1.44 MB, image/png)
2020-02-06 02:31 UTC, G
Details
LibreOffice can't be opened (438.09 KB, image/png)
2020-02-06 16:03 UTC, G
Details
Blurred Font Comparison V6.4.1.2 (663.90 KB, image/png)
2020-03-19 20:48 UTC, Spood
Details
Blurred Font Comparison V6.4.2.2 (1005.51 KB, image/png)
2020-03-19 20:49 UTC, Spood
Details
Diff with experimentation (3.76 KB, patch)
2020-05-01 15:59 UTC, Tor Lillqvist
Details
Screenshot of LO with workaround and without on non-Retina (7.81 KB, image/png)
2020-05-02 19:44 UTC, Tor Lillqvist
Details
Screenshot of LO with workaround and without on Retina display (18.07 KB, image/png)
2020-05-02 19:48 UTC, Tor Lillqvist
Details

Note You need to log in before you can comment on or make changes to this bug.
Description thdeppner 2018-12-20 10:37:04 UTC
Description:
After updating to 6.1.4, the fonts displayed in LO Writer are displayed in a blurred way on a MacBool Pro with retina display.

Only the rendering of fonts in the document window seems affected, fonts used in LO menu items are displayed correctly (crisp). 

Downgrade to 6.1.3 resolved the problem.

Did not test with other components than Writer. OpenGL not enabled; switching it on made no difference.

Steps to Reproduce:
1. Start LO Writer.
2. Type a couple of letters.
3. Realize they are displayed in a blurred way.

Actual Results:
Font in Writer is displayed in a blurred way.

Expected Results:
Font in Writer is displayed correctly (crisp).


Reproducible: Always


User Profile Reset: No



Additional Info:
Comment 1 Maciej Tarmas 2018-12-20 11:29:20 UTC
Created attachment 147691 [details]
Writer

Blurred fonts in Writer
Comment 2 Maciej Tarmas 2018-12-20 11:30:10 UTC
Created attachment 147692 [details]
Calc

Blurred text in Calc
Comment 3 Maciej Tarmas 2018-12-20 11:33:24 UTC
Not only affecting Witer. Also note the blurry interface text in the status bar at the bottom.

Note that when selecting text in a spreadsheet cell, text becomes sharp.

MacBook Pro (Retina, 13-inch, Mid 2014)
macOS 10.14.2 (18C54)
LibreOffice 6.1.4.2
Comment 4 Timur 2018-12-20 14:47:24 UTC
Please try with deleting profile: https://wiki.documentfoundation.org/UserProfile
Comment 5 Maciej Tarmas 2018-12-20 16:16:52 UTC
Nope, deleting the profile doesn't do anything about the issue.
Comment 6 Wojtek 2018-12-21 13:18:28 UTC
Came here to report same issue - fonts are blurry in Calc and Writer (those I use). After selecting the cell the font becomes very clear (actually better that normal display in 7.1.3 as well)
Comment 7 Alex Thurgood 2018-12-21 14:35:31 UTC
Don't seem to be able to reproduce this in either Calc or Writer on a Macbook Pro 2015 with Retina display connected to a Thunderbolt (HiDPI) display.
Comment 8 Alex Thurgood 2018-12-21 14:38:14 UTC
I tested against the default LO font Liberation Sans.
Version: 6.1.4.2
Build ID: 9d0f32d1f0b509096fd65e0d4bec26ddd1938fd3
Threads CPU : 8; OS : Mac OS X 10.14.2; UI Render : par défaut; 
Locale : fr-FR (fr_FR.UTF-8); Calc: group threaded

Is the issue only with Microsoft fonts, or particular font families ?
Comment 9 Maciej Tarmas 2018-12-24 20:36:48 UTC
No, the issue is with all fonts. See the screenshot with Liberation Serif in Writer.

Once again, the font in the status bar at the bottom of the window is also blurred.
Comment 10 Maciej Tarmas 2018-12-24 20:37:51 UTC
Created attachment 147806 [details]
Writer with Liberation Serif

Blurred Liberation Serif in Writer
Comment 11 Alex Thurgood 2018-12-26 08:56:49 UTC
OK, it would have helped having some comparison of before/after, so I did it myself...


First screenshot taken with document in Writer using LO5472
Second screenshot taken with same document in Writer using LO6412.

Notice the marked decrease in font display rendering in the second screenshot.

===> regression
Comment 12 Alex Thurgood 2018-12-26 08:58:31 UTC
Created attachment 147831 [details]
LO5472 screenshot font display
Comment 13 Alex Thurgood 2018-12-26 08:59:03 UTC
Created attachment 147832 [details]
LO6412 screenshot font display
Comment 14 Xisco Faulí 2019-01-17 16:48:08 UTC
Hello
Please, redownload LibreOffice from
https://www.libreoffice.org/download/download/ and reinstall it. We had to
rebuild it with xcode 9 to fix hang/crash problems with Mojave

*** This bug has been marked as a duplicate of bug 121778 ***
Comment 15 Alex Thurgood 2019-01-18 09:33:04 UTC
@Xisco : pretty certain this isn't a DUP of bug 121778.

The screenshot I posted used the 6142 release built with XCode 9
Comment 16 trainman75 2019-07-17 08:48:41 UTC
Created attachment 152823 [details]
Screenshot of Calc LO6.3.0.1

Cell A1 has been entered and lost focus
Cell A2 has text being entered, and retains focus. Also has the clear text rendering.
System is late 2015 MBP with retina, running OSX10.15 beta
Comment 17 Alex Thurgood 2019-08-09 07:36:07 UTC
*** Bug 126775 has been marked as a duplicate of this bug. ***
Comment 18 Joop Lanting 2019-08-12 06:02:35 UTC
I just tried to upgrade to 6.3.0 and
the text in Writer on my Retina iMac looks as bad
as on my wife's non-retina iMac.

I went back to 6.2.5 right away.
;JOOP!
Comment 19 Alex Thurgood 2019-08-13 10:41:25 UTC
*** Bug 126841 has been marked as a duplicate of this bug. ***
Comment 20 Alex Thurgood 2019-08-14 09:21:36 UTC
*** Bug 126907 has been marked as a duplicate of this bug. ***
Comment 21 Alex Thurgood 2019-08-14 09:27:45 UTC
*** Bug 125915 has been marked as a duplicate of this bug. ***
Comment 22 Xisco Faulí 2019-08-15 14:47:46 UTC
*** Bug 126947 has been marked as a duplicate of this bug. ***
Comment 23 Xisco Faulí 2019-08-15 14:55:16 UTC
I'm wondering if this issue in introduced by https://cgit.freedesktop.org/libreoffice/core/commit/?id=959e8ae7ea33ce94dd80ee8ea172b6db64593873 and LibreOffice being built with Xcode 10. Probably it wouldn't happen if we used xcode 9, as in bug 121778

Comments from quikee in IRC:

<quikee[m]> iplaw67: blame Apple as they are silently changing the CG API behavior.
<quikee[m]> iplaw67: We had to change how we draw stuff... and are forced to implement HiDPI support ourselves, which is not yet ready
* MechtiIde ha sortit (Ping timeout: 258 seconds)
Comment 24 trainman75 2019-08-15 16:57:18 UTC
*** Bug 126950 has been marked as a duplicate of this bug. ***
Comment 25 V Stuart Foote 2019-08-16 12:08:36 UTC Comment hidden (obsolete)
Comment 26 trainman75 2019-08-17 05:38:50 UTC
*** Bug 126982 has been marked as a duplicate of this bug. ***
Comment 27 Mark Deepwell 2019-08-17 16:15:04 UTC
Fonts are blurry for me with LibreOffice 6.3.0 on macOS 10.14.5. I've reverted back to LibreOffice 6.2.6 and will stay until this is fixed.
Comment 28 Alex Thurgood 2019-08-19 09:31:36 UTC
*** Bug 127020 has been marked as a duplicate of this bug. ***
Comment 29 Alex Thurgood 2019-08-19 11:12:46 UTC
*** Bug 127023 has been marked as a duplicate of this bug. ***
Comment 30 FChalfant 2019-08-20 12:18:39 UTC
Same problem on my Mac Pro laptop with LibreOffice Calc running 10.14.6 with 6.3, have reverted back to 6.2.6.
Comment 31 Xisco Faulí 2019-08-21 15:58:26 UTC
*** Bug 127084 has been marked as a duplicate of this bug. ***
Comment 32 Christian Lohmaier 2019-08-22 14:35:27 UTC
To rule out (or confirm) XCode 10 being the issue or not:
could you please try with the build from
https://dev-builds.libreoffice.org/daily/libreoffice-6-3/MacOSX-x86_64@49-TDF/2019-08-21_17.28.20/ - that was done with XCode 9
Comment 34 bunkem 2019-08-22 23:42:48 UTC
The font problem is fixed in the build:

https://dev-builds.libreoffice.org/daily/libreoffice-6-3/MacOSX-x86_64@49-TDF/2019-08-21_17.28.20/ - that was done with XCode 9

Version: 6.3.2.0.0+
Build ID: ad2fde8797bd7753987dc1bbbae35fb1cc5ce1df
CPU threads: 8; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
TinderBox: MacOSX-x86_64@49-TDF, Branch:libreoffice-6-3, Time: 2019-08-21_17:28:20
Locale: en-CA (en_CA.UTF-8); UI-Language: en-US
Calc: threaded
Comment 35 mr.viennavienna 2019-08-23 08:24:59 UTC
Fonts are not blurry (In reply to Christian Lohmaier from comment #32)
> To rule out (or confirm) XCode 10 being the issue or not:
> could you please try with the build from
> https://dev-builds.libreoffice.org/daily/libreoffice-6-3/MacOSX-x86_64@49-
> TDF/2019-08-21_17.28.20/ - that was done with XCode 9
Comment 36 trainman75 2019-08-23 13:36:56 UTC
Created attachment 153593 [details]
Comparison 6.3.2.0.0+ and 6.3.0.4

Can confirm the text is blurred in 6.3.0.4, but clear in Dev build 6.3.2.0.0+
Comment 37 Jeremiah Glover 2019-08-24 01:04:35 UTC
(In reply to Christian Lohmaier from comment #32)
> To rule out (or confirm) XCode 10 being the issue or not:
> could you please try with the build from
> https://dev-builds.libreoffice.org/daily/libreoffice-6-3/MacOSX-x86_64@49-
> TDF/2019-08-21_17.28.20/ - that was done with XCode 9

Fonts are not blurry in this build.
Comment 38 Alex Thurgood 2019-08-28 08:14:31 UTC
*** Bug 127177 has been marked as a duplicate of this bug. ***
Comment 39 Joachim 2019-09-05 10:10:48 UTC
Seeing this with 6.3.0. They're fine in 6.2.6.2. 

MacOs 10.14.5.
Comment 40 mr.viennavienna 2019-09-05 13:46:46 UTC
Version 6.3.1.2 has the same issue
(MacBook Pro Retina, late 2013. Mac OS X 10.14.6)
Comment 41 Xisco Faulí 2019-09-05 13:47:49 UTC
(In reply to mr.viennavienna from comment #40)
> Version 6.3.1.2 has the same issue
> (MacBook Pro Retina, late 2013. Mac OS X 10.14.6)

Yep, LibreOffice 6.3.1.2 was built with xcode 10
Comment 42 solarcolombia 2019-09-05 18:23:08 UTC
could somebody please provide a copy of the XCode9 build? Thanks
The old link can not be reached.

https://dev-builds.libreoffice.org/daily/libreoffice-6-3/MacOSX-x86_64@49-TDF/2019-08-21_17.28.20/ - that was done with XCode 9
Comment 43 Mugs 2019-09-07 06:04:32 UTC
All fonts rendered in writer are again blurred. If I downgrade to 6.2.7 all is clear again. Is this because the 6.3 builds are built with Xcode 10?
Comment 44 Joop Lanting 2019-09-12 14:27:03 UTC
Yes, 6.3.1.2 looks awful; going back to 6.2.5.2

Pity: the Merge Cells problem in 6.2 seems to have been solved in 6.3
;JOOP!
Comment 45 laurens 2019-09-12 15:07:07 UTC
uff - indeed calc is
Comment 46 majormahonia 2019-09-15 09:55:23 UTC
font still blurry in 6.3.1
Comment 47 majormahonia 2019-09-15 09:57:12 UTC Comment hidden (no-value)
Comment 48 Xisco Faulí 2019-09-19 15:30:00 UTC
Hi *,
Could someone facing this issue check if there is an option in Info Window called 'Open in Low Resolution' and see if it's checked ? -> https://developer.apple.com/library/archive/documentation/GraphicsAnimation/Conceptual/HighResolutionOSX/Explained/Explained.html#//apple_ref/doc/uid/TP40012302-CH4-SW10

If so, does unchecking it fix the issue?

Thanks in advance
Comment 49 Wojtek 2019-09-19 15:33:53 UTC
I do have that option in LO.app Info window and it is *NOT* checked. In general whole UI is sharp and hi-resolution except for the spreadsheet grid (and, when editing a cell with F2 - the text becomes sharp as well while editing)
Comment 50 Xisco Faulí 2019-09-19 15:35:12 UTC
(In reply to Wojtek from comment #49)
> I do have that option in LO.app Info window and it is *NOT* checked. In
> general whole UI is sharp and hi-resolution except for the spreadsheet grid
> (and, when editing a cell with F2 - the text becomes sharp as well while
> editing)

Thanks for the quick update.
OTOH, what happens if you enable it ?
Comment 51 Wojtek 2019-09-19 16:00:17 UTC
(In reply to Xisco Faulí from comment #50)
> Thanks for the quick update.
> OTOH, what happens if you enable it ?

The whole UI becomes low-resolution / pixelated. I'll upload screenshots for comparison.
Comment 52 Wojtek 2019-09-19 16:01:24 UTC
Created attachment 154296 [details]
Calc after enabling "low resolution" in .app configuration
Comment 53 Wojtek 2019-09-19 16:02:12 UTC
Created attachment 154297 [details]
Calc default display *WITHOUT* enabling "low resolution" in .app configuration
Comment 54 steve -_- 2019-09-23 16:59:53 UTC
*** Bug 127177 has been marked as a duplicate of this bug. ***
Comment 55 war 2019-09-24 08:01:24 UTC
I would appreciate if this issue was dealt with instead of marking issues as duplicates (open since 2018-12-20)

Those of us who want to use LibreOffice are several versions behind.

And just to inform you: XCode has been updated to version 11 now. So spare the discussion of using XCode 9 which is outdated.

I just had a look at the libreoffice website. It reads:

LibreOffice 6:
"The best office suite gets even better" – ZDNet

I would like to participate
Comment 56 war 2019-09-24 09:39:07 UTC
Just tried 6.2.7 (stable) and 6.3.1

6.2.7 has clear sharp fonts, 6.3.1 has the same issue with blurred fonts.

Why can't you take the rendering from 6.2.7 and merge it with 6.3.1?

This issue was reported with 6.1.4 and eliminated in 6.2.x. It came back in 6.3.x.

Completely incomprehesible for a former developer and manager of several development departments.
Comment 57 solarcolombia 2019-09-24 14:53:36 UTC
i have tested ALL available nightly releases, prereleases, etc. 6.2.8 and ALL following show the same stupid mistake (which is quite rediculous). will there be a version for osx after 6.2.7 or do we need to grind down our glasses to get a sharp image on a retina display? And dare to mark this a duplicate!
Comment 58 mr.viennavienna 2019-09-25 09:12:46 UTC
@war and @solarcolombia, if you have the knowledge and time to help the developers to fix some bugs then please bring yourself in.
Comment 59 majormahonia 2019-09-25 19:13:17 UTC
mac has updated itself with new xcode, fonts remain blurry
Comment 60 majormahonia 2019-09-25 19:39:12 UTC
(In reply to war from comment #56)
> Just tried 6.2.7 (stable) and 6.3.1
> 
> 6.2.7 has clear sharp fonts, 6.3.1 has the same issue with blurred fonts.
> 
> Why can't you take the rendering from 6.2.7 and merge it with 6.3.1?
> 
> This issue was reported with 6.1.4 and eliminated in 6.2.x. It came back in
> 6.3.x.
> 
> Completely incomprehesible for a former developer and manager of several
> development departments.

Good point, this was done on comment 32 and confirmed to have worked in comment 33/34
Comment 61 majormahonia 2019-09-25 19:40:32 UTC Comment hidden (no-value)
Comment 62 solarcolombia 2019-09-29 16:13:44 UTC
(In reply to mr.viennavienna from comment #58)
> @war and @solarcolombia, if you have the knowledge and time to help the
> developers to fix some bugs then please bring yourself in.

At least I wouldn't act like a Russian diplomat during cold war by throwing out dozens of versions - knowing - that they ALL contain the same unsolved bug and therefore will keep all folks busy to find out by try and error. AND if you'd asked prior to this charade, then we wouldn't even need to have this discussion. My question - of course - isn't worth an answer. Ignored the same as the problem itself.
Comment 63 eisa01 2019-09-29 16:24:10 UTC
(In reply to solarcolombia from comment #62)
> Ignored the same as the problem itself.

While this seems to have not been prioritized for some time, it's definitely on the radar of the developers now. It's being discussed in the weekly Engineering Steering Committee calls as a "most pressing bug": https://www.mail-archive.com/libreoffice-qa@lists.freedesktop.org/msg10379.html

Latest discussion:
+ probably depends on xcode version (Xisco)
+ but newer xcode is required by notorization (Cloph)
 + ideal would be to build with xcode 10 entirely
 + HiDPI screen for Cloph would be great (Michael)
 + found out: not a regression, but it is from a user’s PoV
Comment 64 majormahonia 2019-09-30 21:00:39 UTC
(In reply to eisa01 from comment #63)
> (In reply to solarcolombia from comment #62)
> > Ignored the same as the problem itself.
> 
> While this seems to have not been prioritized for some time, it's definitely
> on the radar of the developers now. It's being discussed in the weekly
> Engineering Steering Committee calls as a "most pressing bug":
> https://www.mail-archive.com/libreoffice-qa@lists.freedesktop.org/msg10379.
> html
> 
> Latest discussion:
> + probably depends on xcode version (Xisco)
> + but newer xcode is required by notorization (Cloph)
>  + ideal would be to build with xcode 10 entirely
>  + HiDPI screen for Cloph would be great (Michael)
>  + found out: not a regression, but it is from a user’s PoV

Good to hear that this bug is now getting attention. It makes LibreOffice unusable on the mac so should have long been the most urgent bug.
Comment 65 Wojtek 2019-09-30 23:56:44 UTC
@majormahonia

Please kindly don't exaggerate - this bug neither makes 
"LibreOffice unusable" nor is "the most urgent". I agree that it's inconvenient but one can use LO just fine with it (I'm doing LO daily and make a heavy usage of it)! 

Besides, for the time being you can go back to previous release until this bug is fixed (which also works just fine)
Comment 66 majormahonia 2019-10-01 07:07:41 UTC
(In reply to Wojtek from comment #65)
> @majormahonia
> 
> Please kindly don't exaggerate - this bug neither makes 
> "LibreOffice unusable" nor is "the most urgent". I agree that it's
> inconvenient but one can use LO just fine with it (I'm doing LO daily and
> make a heavy usage of it)! 
> 
> Besides, for the time being you can go back to previous release until this
> bug is fixed (which also works just fine)

Please kindly check your facts before posting - there are issues with the previous 6.2.7 version: it hangs after a few second of use, also due to xcode -- to learn more see #14; the 6.2.7 version cannot be notarized, which is important in the workplace -- to learn more  see #63. Furthermore, the main steering committee regard the blurry text as a "most pressing bug" in contrary to your insistence that it is 'nor is "the most urgent"' -- to learn more see #63.
Comment 67 Wojtek 2019-10-01 15:16:19 UTC
> Please kindly check your facts before posting - there are issues with the previous 6.2.7 version: it hangs after a few second of use, also due to xcode -- to learn more see #14;

You mean comment #14? It states that they rebuilt it and it should work. There is also archive with previous builds (https://downloadarchive.documentfoundation.org/libreoffice/old/) which, if you were using one of them before, you should downgrade to it without any issue.

> the 6.2.7 version cannot be notarized

Could you explain in your own words what does that mean?
Comment 68 war 2019-10-02 20:13:24 UTC
I've tried 6.3.2
The issue still exists.
Fonts are blured and barely legible.

6.2.7 displays sharp fonts
Comment 69 war 2019-10-02 20:21:54 UTC
Addition to #68:

I realised that the menus and the fonts on the side of the launcher are sharp again.
It is just the fonts and the font menu that are still blured.

Tested Writer, Calc, Impress and Draw. All have the same issue.
Comment 70 lainvoo 2019-10-17 10:08:32 UTC
The issue still remains. Public releases LibreOffice 6.3.2.2 and even LibreOffice 6.3.3.1 have the same blurry text issue.

Yet at the same time developer releases LibreOfficeDev 6.3.2.0 and LibreOfficeDev 6.3.3.0 do not have this problem.

I hope the xcode version issue gets solved and with that this problem as well.
Comment 71 Alex Thurgood 2019-10-18 12:44:09 UTC
*** Bug 128118 has been marked as a duplicate of this bug. ***
Comment 72 Roberto Zanandrea 2019-10-18 18:29:31 UTC Comment hidden (obsolete)
Comment 73 svoop 2019-10-20 11:46:56 UTC
It's maybe worth noting that while the fonts are rendered lasersharp with LO 6.2.x in standard mode, switching to design mode will blur the fonts on LO 6.2.x as well.
Comment 74 majormahonia 2019-10-22 12:51:30 UTC
Confirmed 6.3.2.2 update still has this issue
Comment 75 solarcolombia 2019-10-22 14:06:10 UTC
installed 6.3.3.0 dev after your message. it works flawlessly so far.

(In reply to lainvoo from comment #70)
> The issue still remains. Public releases LibreOffice 6.3.2.2 and even
> LibreOffice 6.3.3.1 have the same blurry text issue.
> 
> Yet at the same time developer releases LibreOfficeDev 6.3.2.0 and
> LibreOfficeDev 6.3.3.0 do not have this problem.
> 
> I hope the xcode version issue gets solved and with that this problem as
> well.
Comment 76 war 2019-10-24 19:26:13 UTC
Now this issue occurs in 6.2.8.2 also.

If anything convinced me moving back to MS Office then it is this issue.
Comment 77 majormahonia 2019-10-26 11:32:06 UTC Comment hidden (no-value)
Comment 78 exprez135 2019-10-26 17:43:05 UTC
The problem seems to continue in 6.4.0.0 Alpha 1 on MacOS 10.15.1.
Comment 79 majormahonia 2019-10-26 19:10:41 UTC Comment hidden (no-value)
Comment 80 exprez135 2019-10-28 23:38:46 UTC
Has anyone been able to test building with xcode 11?
Comment 81 Mike Newman 2019-10-29 10:30:36 UTC
Created attachment 155389 [details]
Fuzzy: Open Office vs Libre Office

Sceenshot showing the same Writer document open in both LibreOffice and OpenOffice
Comment 82 Mike Newman 2019-10-29 10:34:15 UTC
The bug doesn't affect our MBA but makes documents almost unreadable on my 2017 iMac. In the attachment "Fuzzy: Open Office vs Libre Office" the same Writer document is shown in both Open Office and LibreOffice.
Comment 83 majormahonia 2019-10-31 21:38:29 UTC
After updating to 6.3.3 the fonts are still blurry.
Comment 84 Brandon 2019-10-31 21:44:48 UTC
Now this is interesting.  Had this problem on a 2019 iMac, macOS 10.4.6, in both LO 6.3.3 and 6.2.8, which I had downloaded by torrent.  Then I went to the archive, installed 6.2.7.1, and saw no blurriness.  

Reran 6.2.8, and macOS prompted that as a downloaded app, it needed to be verified.  Launched a calc doc, and no blurriness.

Reran 6.3.3, didn't get the verification prompt, and still blurry.

Happy to provide other info.

I will say this:  this bug may have started for me when I downloaded LO on my 2012 non-retina MacBook Pro, and then copied it over to my retina iMac.  I think this might have something to do with macOS "verifying" newly downloaded apps?
Comment 85 Brandon 2019-10-31 21:57:19 UTC
Thinking there might be a difference between torrented and direct-downloaded versions, I just tried running a direct-downloaded 6.3.3, but that didn't fix it.

I don't know why running 6.2.7.1 seems to have "fixed" the blurriness in 6.2.8 (which I had renamed to LibreOffice6.2.8.app) but can't get 6.3.3 fixed.
Comment 86 majormahonia 2019-10-31 22:05:58 UTC Comment hidden (no-value)
Comment 87 Olivier Croquette 2019-11-01 08:25:29 UTC
Also got hit by this bug after updating from 5.x to 6.3.2.2 on Mojave. Used font: "Liberation Sans" in Calc. Even the text in the "About" dialog is affected.

I cannot confirm the reports of war@rsb.at and majormahonia. 6.2.8.2 works fine for me on Mojave and is an acceptable workaround for now.

Still, this kind of regression is very unfortunate when users are actively encouraged to update. It took me a few minutes to update, 10 minutes to troubleshoot and find this ticket, and 5 more to create an account and write this, and a few more minutes to downgrade. I hope that the latest and greatest version gets fixed soon.
Comment 88 Maciej Tarmas 2019-11-01 17:45:31 UTC
(In reply to Olivier Croquette from comment #87)
> I hope that the latest and
> greatest version gets fixed soon.

It won't. Nobody at The Document Foundation gives a crap about the Mac port of Libre Office.

This bug was reported almost a year ago. As I understand it, the fix is to build the binaries with a newer version of Xcode, but it seems that the devs can't be bothered with stuff like that.

Sometimes I wish OpenOffice was never forked and stayed with Oracle. They're doing a great job with VirtualBox on the Mac. Sigh.
Comment 89 war 2019-11-02 12:58:10 UTC
@Olivier Croquette

I use 10.15.1 (Catalina) and 6.2.8.x unfortunately has the issue. Not in all places but certainly in documents, spreadsheets and impress presentations documents (didn't test draw, math and database).

I tested documents using LOs standard fonts (Liberation Sans/Serif) as well as Macs standard fonts Helvetica Neue and Times New Roman.

In all cases, there is a shadow around the letters.

I can confirm that Microsoft Office products reproduce these fonts clear and sharp (They have other, even more serious issues, but that's not relevant for this fact)

Just a final note on the supposed issues with XCode:

XCode gets updated every 3 months or so (currently being 11.2 (11B52)).
Comment 90 majormahonia 2019-11-03 22:21:54 UTC Comment hidden (no-value)
Comment 91 majormahonia 2019-11-06 09:25:26 UTC
macOS updated to Mojave 10.14.6 Update, but Libreoffice fonts are still blurry
Comment 92 Alex Thurgood 2019-11-07 06:28:24 UTC
*** Bug 128636 has been marked as a duplicate of this bug. ***
Comment 93 Frank Fuchs 2019-11-10 15:23:02 UTC
I do not know if it helps:
While you are editing a cell in Calc, the fonts in this particular cell are not blurred. Once you stop editing, they are blurred, again.

Unbelievable, that this bug is not treated as a showstopper - absolutely no new release until it is solved.
Comment 94 majormahonia 2019-11-10 15:26:37 UTC Comment hidden (no-value)
Comment 95 eisa01 2019-11-10 15:52:04 UTC
Yeah, this is a _very_ bad bug, especially considering it's 7 years since Retina screens came out. Honestly, the newer builds should be taken down, or the download page need to be adjusted to point to the most recent working version.

Before it is fixed, and if you need to be on a more recent version, LibreOffice Vanilla in the App store is on version 6.2.6 and has Retina support (apart from the toolbar icons)

I don't know the price as I've already bought it, but I think it's 20-30 EUR

https://apps.apple.com/no/app/libreoffice-vanilla/id921923693?mt=12
Comment 96 trainman75 2019-11-11 02:30:28 UTC
In an effort to narrow down the issue, I have built 6.4 from source on Catalina with Xcode11. Text in documents etc is still blurry, but my observation is that something has changed along the way.
Anything built on Xcode9 has clear text, as we know.
6.3/6.4 built on Xcode10, I noticed the About box text was also blurry.
Now, my 6.4 build on Xcode11 has fuzzy text in docs, but the About box is now sharp.

Was anything changed recently that could have affected the About box but not in-document text rendering?
Comment 97 majormahonia 2019-11-23 11:22:49 UTC Comment hidden (no-value)
Comment 98 Alex Thurgood 2019-11-26 08:19:37 UTC
*** Bug 128936 has been marked as a duplicate of this bug. ***
Comment 99 muhadi 2019-12-06 17:10:01 UTC
(In reply to eisa01 from comment #95)
> Yeah, this is a _very_ bad bug, especially considering it's 7 years since
> Retina screens came out. Honestly, the newer builds should be taken down, or
> the download page need to be adjusted to point to the most recent working
> version.
> 
> Before it is fixed, and if you need to be on a more recent version,
> LibreOffice Vanilla in the App store is on version 6.2.6 and has Retina
> support (apart from the toolbar icons)
> 
> I don't know the price as I've already bought it, but I think it's 20-30 EUR
> 
> https://apps.apple.com/no/app/libreoffice-vanilla/id921923693?mt=12

But that particular version had Calc bugs that was fixed in 6.3.3 is there any fixed version released yet?
Comment 100 m.a.riosv 2019-12-08 08:14:49 UTC
*** Bug 129272 has been marked as a duplicate of this bug. ***
Comment 101 bunkem 2019-12-08 18:52:27 UTC
Till having blurry fonts in 6.4beta1
Version: 6.4.0.0.beta1
Build ID: 4d7e5b0c40ed843384704eca3ce21981d4e98920
CPU threads: 8; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-CA (en_CA.UTF-8); UI-Language: en-US
Calc: threaded

As far as I can tell, the last version that was OK in the release track was 6.2.8.

Last beta that was OK was 6.3.3beta1
Comment 102 majormahonia 2019-12-08 22:16:19 UTC Comment hidden (off-topic)
Comment 103 trainman75 2019-12-09 01:36:41 UTC
The reason for the regression has been identified as changing from using XCode9 to XCode10 to build LibreOffice. Those versions built with 9 look fine, those with 10 are blurry. As for what changed in XC10, that is well beyond my level, and most of my searching gets results related to font display "within" the XCode IDE, not for fonts displayed by apps "built with" Xcode's Command Line Tools.

I did note back in comment 16 that in Calc, text rendering is great while new text is being entered into a cell, but once the text is (I guess) handed over to another portion for display once stored in the sheet, it then appears fuzzy.

The problem seems, from what I have found out, to stem from Xcode10 no longer using/accepting sub-pixel antialiasing. Some reports have suggested changing from sub-pixel to greyscale font smoothing as a fix. Again, I don't really know where to even look, much less what to look for.

So, where to from here? Again, well beyond my knowledge. I've poked around in the source, particularly core/vcl/osx, but I don't really know what to look for, so it's largely unproductive on my part. Other apps have adapted, many of which are also open source, so whether devs from those apps are able/willing to assist I don't know, but I guess it would start by someone asking them.

And because Apple are implementing code signing etc, continuing to use Xcode9 appears not to be an option.
Comment 104 war 2019-12-10 09:34:39 UTC
@ trainman75@gmail.com

Current version of XCode is Version 11.2.1 (11B500). Maybe you do not try to fix an outdated issue with an outdated tool.

Even for a newbie to MacOS like myself (thanks to Ubuntu), I have learned quickly that MacOS 10.14.x and following have a different rendering method.

I presume that you do not search in the right places. Apple offers a developer site where text rendering is clearly documented including source code. You also find a warning that using something else but Cocoa will produce unpredictable results.

https://developer.apple.com/documentation/xcode_release_notes/xcode_11_release_notes
https://developer.apple.com/library/archive/documentation/TextFonts/Conceptual/CocoaTextArchitecture/FontHandling/FontHandling.html#//apple_ref/doc/uid/TP40009459-CH5-SW1
Comment 105 Maciej Tarmas 2019-12-10 22:15:29 UTC Comment hidden (no-value)
Comment 106 war 2019-12-12 16:20:32 UTC Comment hidden (no-value)
Comment 107 solarcolombia 2019-12-12 16:50:09 UTC Comment hidden (no-value)
Comment 108 Diego Caravana 2019-12-14 17:02:28 UTC
Bug still present in 6.4.0.0.beta1, except for the About pane which appears as expected.
Comment 109 laurens 2019-12-16 11:11:24 UTC
I would like to add that I really hope this gets fixed and if there is somewhere I can contribute a few bucks to get this fixed, above my normal yearly Document Foundation donations then let me know. 

As a freelancer I have "standardised" on LibreOffice as it is cross-platform, and I have pushed clients and customers to move away from MS Office 365 and towards LO for technical documentation. That a basic issue like text rendering through standard API is not implemented is a big problem for use.

With age and decreasing eyesight text sharpness is very important for accessibility - so if any of the younger programmers want to feel they are contributing. they can very well consider this bug to be an accessibility one as well - for the oft ignored and maligned "older people" demographic.
Comment 110 solarcolombia 2019-12-17 20:05:33 UTC
I gave 6.5... a chance: Crisp and clear. glad not to have to move to excel.
Comment 111 Jan Severin 2019-12-17 20:44:18 UTC
Hi
Hi
I can't find version 6.5 in downloads. 
Can you help telling me where to find version 6.6
Comment 112 Jan Severin 2019-12-17 20:46:23 UTC
Hi

I can't find version 6.5 in downloads.
Can you help telling me where to find version 6.5
Comment 113 eisa01 2019-12-17 21:01:17 UTC
You can access the nightly builds here, I downloaded the current build (December 17)

https://dev-builds.libreoffice.org/daily/master/MacOSX-x86_64@tb81-TDF/

Yup, it's now crisp again, apart from the lower bar where e.g., "Sum" and so on is displayed in Calc (only opened Calc)

Version: 6.5.0.0.alpha0+
Build ID: 148ed6c2739ab8af88c0ac363f30f99f10bf7c1a
CPU threads: 4; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-US (en_US.UTF-8); UI-Language: en-US
Calc: threaded
Comment 114 eisa01 2019-12-17 21:03:48 UTC
(In reply to eisa01 from comment #113)
> Yup, it's now crisp again, apart from the lower bar where e.g., "Sum" and so
> on is displayed in Calc (only opened Calc)
Sorry spoke to fast, the cell-contents are not crisp, but the rest of the UI in Calc is
Comment 115 solarcolombia 2019-12-17 22:21:12 UTC
Yes, LO. You made me look a bit stupid. And I am quite glad. 6.5 is better than any previous version (for Osx). I run a couple of old simulations (which are not possible to carry out with excel...) without any issues. Muchas Gracias from Colombia. May god and such do something good for you ;)
Comment 116 solarcolombia 2019-12-17 22:23:57 UTC
(In reply to eisa01 from comment #114)
> (In reply to eisa01 from comment #113)
> > Yup, it's now crisp again, apart from the lower bar where e.g., "Sum" and so
> > on is displayed in Calc (only opened Calc)
> Sorry spoke to fast, the cell-contents are not crisp, but the rest of the UI
> in Calc is

Not a single problem here (MacBook Pro Retina) with the display quality. Actually, font rendering looks far better (Thunderbolt display too) than in any previous versions).
Comment 117 bunkem 2019-12-18 01:45:23 UTC
Not sure what you guys are seeing but the 6.5alpha that I downloaded still has fuzzy text in the calc sheet.

I've tried various fonts but it still looks like crap.

Same with the text in Writer.

OK a bit better because all the icons and text in formula bar are OK but still no prize.

15" MBP Retina
Comment 118 steve -_- 2019-12-18 12:34:02 UTC
Created attachment 156647 [details]
Writer with Liberation Serif, recreated w 6.5 for comparison
Comment 119 steve -_- 2019-12-18 12:41:41 UTC
Recreated the "Writer with Liberation Serif" screenshot using LO 6.5 on macOS 10.14.6.

Once identified what caused the much improved situation I think this can be closed and remaining issues should be filed as new bugs as those need different fixes. But let's wait what QA / dev department has to say about this.
Comment 120 Wolfgang Glas 2019-12-19 09:18:13 UTC
If this issue is fixed LO 6.5, please provide a backport to LO 6.4 or even better LO 6.3

TIA, Wolfgang Glas
Comment 121 work 2019-12-19 10:10:07 UTC
Created attachment 156669 [details]
Screenshot of LO BASE form, design mode OFF

Design mode OFF
Comment 122 work 2019-12-19 10:11:30 UTC
Created attachment 156670 [details]
Screenshot of LO BASE form, design mode ON

Design mode ON
Comment 123 work 2019-12-19 10:13:02 UTC
Having checked version 6.5.0.0.alpha0+ (Build ID: 491e8f60bf7f216a3bb3092b22334924b6c9aee1) on MacBook Pro 13 Retina, Mac OSX 10.14.6, here is the situation: on a form build with LO Base (which is basically a Writer doc, AFAIK), there is a difference when "Design" mode is switched ON or OFF.

Design mode ON: Button text is blurred, text written in the form is blurred 
Design mode OFF: Button text seems to be perfectly displayed, text written in the form still blurred 

Hope this helps.
Comment 124 work 2019-12-19 10:21:19 UTC
Created attachment 156671 [details]
Screenshot of LO BASE main window

Version: 6.5.0.0.alpha0+
Build ID: 491e8f60bf7f216a3bb3092b22334924b6c9aee1
Comment 125 Aron Budea 2019-12-19 22:48:54 UTC
(In reply to steve -_- from comment #119)
> Once identified what caused the much improved situation I think this can be
> closed and remaining issues should be filed as new bugs as those need
> different fixes. But let's wait what QA / dev department has to say about
> this.
I'd assume systems that can be used to reproduce this bug are extremely scarce in the QA / dev department.
Comment 126 Vernon 2019-12-23 10:05:04 UTC
*** Bug 129562 has been marked as a duplicate of this bug. ***
Comment 127 Roger Paradise 2019-12-23 23:47:38 UTC
Created attachment 156767 [details]
Comparison of 6.2.8.2 and 6.4.0.1 on MacBook Pro 2014.

Screenshot showing comparison of 6.2.8.2 and 6.4.0.1 on MacBook Pro 2014. Still seeing the bug.
Comment 128 Kithairon 2019-12-27 17:36:39 UTC
Just tried out on 6.5.0.0.alpha0+.  Unfortunately, the issue persists in build 6.5: the fonts are still badly blurry (macOS 10.14.6 / MacBoook Pro Retina [2015] + Dell Monitor).
LibreOffice 6.2.8.2 is the last version still ok; every build since is affected.
Comment 129 muhadi 2019-12-27 20:19:01 UTC
(In reply to Kithairon from comment #128)
> Just tried out on 6.5.0.0.alpha0+.  Unfortunately, the issue persists in
> build 6.5: the fonts are still badly blurry (macOS 10.14.6 / MacBoook Pro
> Retina [2015] + Dell Monitor).
> LibreOffice 6.2.8.2 is the last version still ok; every build since is
> affected.

Confirming the same symptoms (macOS 10.15.2 / MacBook Air 2019)
Comment 130 Maciej Tarmas 2019-12-27 20:31:44 UTC Comment hidden (no-value)
Comment 131 Sebastian Djupsjöbacka 2019-12-28 08:26:46 UTC
Just wanted to report that after having the blurry font problem with all versions after than 6.2.7.1, the nightly builds of 6.5a seem to solve the problem for me. No blur in Writer nor Calc with this build on an 27" iMac Late 2009.

Version: 6.5.0.0.alpha0+
Build ID: e22a3f596ce50b5166063e217d96ef674a54d380
CPU threads: 2; OS: Mac OS X 10.13.6; UI render: default; VCL: osx; 
Locale: en-US (en_FI.UTF-8); UI-Language: en-US
Calc: threaded
Comment 132 Mike Kaganski 2019-12-28 08:55:15 UTC
The reports about 6.5 daily builds alternate stating "solved" vs "not solved". It might depend on where (on which build box) the build was created; so please state exact download link when reporting if a build worked or not worked for you. Thanks!
Comment 133 Sebastian Djupsjöbacka 2019-12-30 21:55:57 UTC
Daily build 2019-12-30 works well, still no blur. This time the report also contains the exact download link as requested.

Version: 6.5.0.0.alpha0+
Build ID: e258dcb9134be64a826547407de3482e5bb2a80b
CPU threads: 2; OS: Mac OS X 10.13.6; UI render: default; VCL: osx; 
Locale: en-US (en_FI.UTF-8); UI-Language: en-US
Calc: threaded

Download link: https://dev-builds.libreoffice.org/daily/master/MacOSX-x86_64@tb81-TDF/2019-12-30_05.29.53/LibreOfficeDev_6.5.0.0.alpha0_MacOS_x86-64.dmg
Comment 134 Roger Paradise 2019-12-30 23:00:44 UTC
I installed the version from the 6.5.0.0 alpha link just provided. I'm still seeing the problem. (MacBook Pro 2014)
Comment 135 Chris Shaw 2019-12-31 11:40:48 UTC
Created attachment 156860 [details]
Comparison of 6.1.6.3 and 6.5.0.0 2019-12-30 build (400%)

Confirmation that the problem still exists in latest nightly build (Macbook Air 2018)
Comment 136 Chris Shaw 2019-12-31 11:44:32 UTC
Created attachment 156861 [details]
Comparison of 6.1.6.3 and 6.5.0.0 2019-12-30 build (400% - Macbook Air 2018)

Confirmation that the problem still exists in latest nightly build
Comment 137 bunkem 2019-12-31 18:39:45 UTC
I can confirm that 6.5alpha 2019-12-31 still has the problems.
Comment 138 majormahonia 2020-01-01 08:51:33 UTC
Confirming that 6.5.0.0 from 31 December 2019 tested on Macbook 12 running Mojave 10.14.6 still has blurry fonts
Comment 139 nabili 2020-01-01 12:37:12 UTC
does this bug report is also about blurry icons of the toolbar, or does it only concerns blurry fonts as suggested on it's title?
Comment 140 Roman Kuznetsov 2020-01-02 15:51:46 UTC
*** Bug 129727 has been marked as a duplicate of this bug. ***
Comment 141 Thorsten Wagner 2020-01-02 17:31:56 UTC
SDK 10.13 seems to be the only SDK to build LO with sharp text on retina displays. Sharp text is back again on macOS Mojave with SDK 10.13 too.

Minimum SDK release is currently 10.12. Due to API changes between SDK 10.12 and 10.13 which have been incorporated in LO code already, LO cannot be build with SDK 10.12.

Mimimum SDK release should be increased to 10.13. Furthermore LO should be build with SDK 10.13 only until issue is fixed (maybe an issue of Apple within Carbon code).

Although Xcode ships with a current release of the SDK, it is possible to install additional SDKs here:

/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs

Additional SDKs can be extracted from ealier Xcode releases, which are all downloadable from Apple.

SDK with lowest (oldest) release is is choosen by LO build scripts. Unitl minimum SDK release has not been increased to 10.13, a lower (older) release than 10.13 should not be installed side by side.
Comment 142 strongleg 2020-01-04 11:59:27 UTC
I have encounter this issue too, here is my report:

1. iMac Retina 5K 27-inch 2017, macOS Mojave
2. I found this issue with LibreOffice 5.x, sorry I forget
3. After I update to LibreOffice 6.2.8.2, this issue disappear for one or two days, font became sharp and clear. But during this time, the Chinese Input Method can't display hint box in LibreOffice, so I have to guess what to type. Meanwhile the Chinese Input Method and its hint box works fine in all other softwares.
4. Today the font becomes blurred again, but the hint box issue of the Chinese input method disappear. I dont't know I should feel lucky or sad. :-(

hope this is helpfull.
Comment 143 Mike Kaganski 2020-01-04 13:54:54 UTC
(In reply to Thorsten Wagner from comment #141)
> SDK 10.13 seems to be the only SDK to build LO with sharp text on retina
> displays. Sharp text is back again on macOS Mojave with SDK 10.13 too.

Do you mean that later SDK versions produce blurry display? I'm asking because I got this impression from your message, and from overall discussion, but generally your message proceeds to mainly discuss non-applicativity of 10.12, so I guessed I'd better ask.

> Minimum SDK release is currently 10.12. Due to API changes between SDK 10.12
> and 10.13 which have been incorporated in LO code already, LO cannot be
> build with SDK 10.12.
> 
> Mimimum SDK release should be increased to 10.13.

https://gerrit.libreoffice.org/c/core/+/86216

> Furthermore LO should be
> build with SDK 10.13 only until issue is fixed (maybe an issue of Apple
> within Carbon code).

Created https://gerrit.libreoffice.org/c/core/+/86218 for you, with which you could come to ESC to discuss this (disclaimer: I don't have a mac). Please do.

> SDK with lowest (oldest) release is is choosen by LO build scripts. Unitl
> minimum SDK release has not been increased to 10.13, a lower (older) release
> than 10.13 should not be installed side by side.

This looks incorrect: the changes I mentioned above show that the check order was from latest to oldest...
Comment 144 Thorsten Wagner 2020-01-04 14:35:59 UTC
Results of my investigantions are as follows:

SDK 10.12 and earlier: build of LO 6.x broken due to SDK API changes
SDK 10.13:             sharp text on retina displays
SDK 10.14:             blurry text on retina displays
SDK 10.15:             blurry text on retina displays

I am currently work around this issue using --with-macosx-sdk=10.13. This can be archived with Xcode 11 by installing SDK 10.13 side by side in platform specific developer directory within Xcode.app.

I did not investigate build code to choose SDK release. Choosing the lowest (oldest) SDK release number was my understanding from help text given by configure. If it works different and highest (newest) SDK release number is choosen, blurry text is the result, e.g. with Xcode 11 (see above).
Comment 145 Emmeran Seehuber 2020-01-06 13:09:19 UTC
I also tried to look into it. (master on MacOS 10.15.2 with SDK 10.15)

AquaSalGraphics::CheckContext(): The backingScaleFactor of the window is correct (2.0 for Retina) and so is the size of the CGLayer used as draw buffer for the window (i.e. twice the window width x height). That looks all fine.

For me it seems something gets into a broken state in the CGContextRef while painting the document content. Because not only the text but also all lines are blurred. 

This is just guessing, but maybe a scale with a factor other than 2 or something like this? It would have to be something affected at compile time, i.e. a constant of the SDK headers which changed between SDK 10.12 and 10.13. Or a helper function in a SDK library.

The strange thing is, the print preview of Calc looks fine, i.e. not blurry, everything sharp. The print preview of Writer on the other side is blurry. I have this effect both with my master build and the official 6.3.4.2 build.

So the print preview of Calc does something different than the rest, because it seems the CGContextRef is not getting in this bogus blurry state. 

Any idea how to investigate this future? (I'm new to the LibreOffice code base; Pointers are welcome)
Comment 146 Roman Kuznetsov 2020-01-11 12:30:32 UTC
*** Bug 129941 has been marked as a duplicate of this bug. ***
Comment 147 eisa01 2020-01-23 12:29:31 UTC
Have anyone verified the proposed fix in comment 114?

I tried compiling the nightly with LODE, but got a compilation error

It would be important to have this fix in place for 6.4, as the last working version for a majority of Mac users (6.2) will become unsupported?
Comment 148 Wim M 2020-01-28 14:28:01 UTC
Just installed LibreOffice 6.4.0.3 (RC3) on my retina Macbook Pro (2015) running macOS Catalina (10.15.2). Fonts in the UI (dialogue boxes, dropdown menus) are rendered sharply, but the text in Writer is still blurry, similar to what was described in comment #69.

I noticed that the bug reappeared in the most pressing bugs list in the ESC minutes. Earlier comments here suggest that there may be a fix for the 6.5.. branch. If there are, any chance that it can be backported into the 6.4.. branch? It would be a shame if Mac retina users have to wait until 6.5 before we can have sharp fonts again. It appears also from the earlier comments that some people can live with blurry fonts while others cannot. I belong to the latter camp so I have reverted back to 6.2.8 for the time being. Thank you to everyone who has put time into fixing this so far.
Comment 149 Joop Lanting 2020-01-28 15:42:38 UTC Comment hidden (no-value)
Comment 150 eisa01 2020-01-28 20:17:20 UTC
Created attachment 157485 [details]
LO Vanilla 6.2.6.2 vs 6.5 Nighly

(In reply to eisa01 from comment #147)
> Have anyone verified the proposed fix in comment 114?
> 
> I tried compiling the nightly with LODE, but got a compilation error
> 
> It would be important to have this fix in place for 6.4, as the last working
> version for a majority of Mac users (6.2) will become unsupported?

Got it working using make build-nocheck

LO is now rendering crisp

Can we have the release versions built with the 10.13 SDK?

Blurry fonts are not only annoying, but an ergonomic issue that puts extra strain on your eyes

Version: 6.5.0.0.alpha0+
Build ID: 6095612850973388ba5b121b34d02292a2548e7d
CPU threads: 4; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-US (en_US.UTF-8); UI-Language: en-US
Calc: threaded
Comment 151 majormahonia 2020-01-30 17:23:10 UTC
Libreoffice 6.4 is blurry on macOS Mojave 10.14.6
Comment 152 brettjralton 2020-01-31 22:05:58 UTC
Created attachment 157572 [details]
Fuzzy display on 2019 iMac 5K (Retina Display), macOS 10.15.3, LO 6.4.0.3

I am suffering from this as well, 2019 5K iMac (Retina Display), fuzzy text rendering in LibreOffice 6.4.0.3, macOS 10.5.3 Catalina.

I turned on OpenGL rendering "for all rendering" and it made no difference.

What would be helpful to submit in this bug report?

Version: 6.4.0.3
Build ID: b0a288ab3d2d4774cb44b62f04d5d28733ac6df8
CPU threads: 6; OS: Mac OS X 10.15.3; UI render: GL; VCL: osx; 
Locale: en-CA (en_CA.UTF-8); UI-Language: en-US
Calc: threaded
Comment 153 majormahonia 2020-02-01 14:16:31 UTC
Libreoffice 6.4 is blurry on Macbook 12 2006 running macOS Catalina (10.15.2)
Comment 154 Arvid 2020-02-04 01:15:19 UTC
On a late 2019 Macbook Pro 16" with macOS 10.15.3:

LibreOiffceDev 7.0.0 alpha from

https://dev-builds.libreoffice.org/daily/master/MacOSX-x86_64@tb81-TDF/2020-01-30_05.11.46/LibreOfficeDev_7.0.0.0.alpha0_MacOS_x86-64.dmg

and LibreOiffce 6.3.3002 both have blurry (non-retina/non-hiDPI) fonts in writer on the computer's built-in retina display.
Comment 155 G 2020-02-06 02:24:57 UTC
Had Libreoffice 6.2.8.2 up to Yesterday. All Fonts and looked good. I mostly use Calc
Since updated to 6.3.4, the Fonts of any written text are Blurry. Even when you have a Drop down list, the First Item looks Good, but the rest on the drop down list looks blurry. Example, you select the "Fonts" drop down list, and the one that is showing on the menu looks good, but the rest that are in the drop down look blurry as the text in written in the page. 
When selecting text in a spreadsheet cell, text becomes sharp. As soon as go to a different cell, the cell previously being edited gets blurry again.
On version 6.4 Fonts are Blurry too.
Even on the "About LibreOffice" the main text is blurry, but the menues and titles are sharp.

On the comments somebody said that this Blurrines doen't make LibreOffice Unnusable, but when you work with it every day, it makes really but really hard to work on. Not Unusable but I really don't like to work on it. I even thought about buying MS Office to keep working on my Calc/Excel sheet.
Maybe when you see the screen shot, the text doesn't look so bad, but when you are working on a Document, with all the text being Blurry, is Very Very hard to work.
I don't know if is the API/XCode/SDK or something else, but is hard to look at.
As I don't have the original download of the 6.2.8.2 (deleted the file long time ago), I can't reinstall it, MacOS doesn't let me run it because is not signed/verifiable or else, don't know.

Screen shots taken on 2020/02/04 and 05
Running on a MacBook Pro 2015, OSX 10.15.3, LibreOffice 6.3.4.2
Comment 156 G 2020-02-06 02:28:52 UTC
Created attachment 157682 [details]
Drop down list first item sharp and the rest is blurry
Comment 157 G 2020-02-06 02:30:06 UTC
Created attachment 157683 [details]
Row 8 has text previously writen and Row 9 is being edited/selected
Comment 158 G 2020-02-06 02:31:42 UTC
Created attachment 157684 [details]
Blurry text on About LibreOffice
Comment 159 work 2020-02-06 12:35:28 UTC
(In reply to G from comment #155)
> Had Libreoffice 6.2.8.2 up to Yesterday. All Fonts and looked good. I mostly
> use Calc
> Since updated to 6.3.4, the Fonts of any written text are Blurry. Even when
> you have a Drop down list, the First Item looks Good, but the rest on the
> drop down list looks blurry. Example, you select the "Fonts" drop down list,
> and the one that is showing on the menu looks good, but the rest that are in
> the drop down look blurry as the text in written in the page. 
> When selecting text in a spreadsheet cell, text becomes sharp. As soon as go
> to a different cell, the cell previously being edited gets blurry again.
> On version 6.4 Fonts are Blurry too.
> Even on the "About LibreOffice" the main text is blurry, but the menues and
> titles are sharp.
> 
> On the comments somebody said that this Blurrines doen't make LibreOffice
> Unnusable, but when you work with it every day, it makes really but really
> hard to work on. Not Unusable but I really don't like to work on it. I even
> thought about buying MS Office to keep working on my Calc/Excel sheet.
> Maybe when you see the screen shot, the text doesn't look so bad, but when
> you are working on a Document, with all the text being Blurry, is Very Very
> hard to work.
> I don't know if is the API/XCode/SDK or something else, but is hard to look
> at.
> As I don't have the original download of the 6.2.8.2 (deleted the file long
> time ago), I can't reinstall it, MacOS doesn't let me run it because is not
> signed/verifiable or else, don't know.
> 
> Screen shots taken on 2020/02/04 and 05
> Running on a MacBook Pro 2015, OSX 10.15.3, LibreOffice 6.3.4.2

You can download it from here 
https://www.libreoffice.org/download/download/?type=mac-x86_64&version=6.2.8&lang=en

After having installed it, goto /Applications and right-click on LibreOffice.app and select "Open" (right-click allows to open unsigned applications)
Comment 160 G 2020-02-06 16:03:02 UTC
Created attachment 157702 [details]
LibreOffice can't be opened

Downloaded from the given Link, but still can't run it.
Comment 161 Wim M 2020-02-10 15:54:37 UTC
(In reply to G from comment #160)
> Created attachment 157702 [details]
> LibreOffice can't be opened
> 
> Downloaded from the given Link, but still can't run it.

As stated in comment #159: you can run such files if you right-click the file, or ctrl-click or hold two fingers on your trackpad when you click it. It will then show you a slightly different dialog where one of the options is to open the app anyway. Once you do that, LO 6.2.8 runs fine on Catalina.
Comment 162 Jan Iversen 2020-02-12 10:07:35 UTC
I can reproduce this problem with Libreoffice 6.4.0 and Mac OS Catalina 10.15.3 on a MacBook Pro 13 2019. Fonts are blurry, wether I use an external display with FullHD or the internal retina-display. A patch would be highly appreciated.
Comment 163 xeros 2020-02-13 10:09:41 UTC
MacOS X 10.14.6 Mojave,
both 6.4.0.3 & 6.4.1.1 (downloaded directly from your website) are affected by this bug.
Even fields in spreadsheets look awful and text is hard to read.
I haven't experienced it in older 6.2.x builds.
Comment 164 xeros 2020-02-13 10:48:21 UTC
7.0.0.0-alpha0 builds are still affected, too:

Version: 7.0.0.0.alpha0+
Build ID: 5d00a1c9c6e85f3d7a3e05ab485da79980c38d44
CPU threads: 8; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-US (en_PL.UTF-8); UI-Language: en-US
Calc: threaded
Comment 165 xeros 2020-02-13 11:10:18 UTC
I can confirm that last working properly (NOT affected by this bug) version is 6.2.8.2, downloaded from here:

https://www.libreoffice.org/donate/dl/mac-x86_64/6.2.8/en-GB/LibreOffice_6.2.8_MacOS_x86-64.dmg

Version: 6.2.8.2
Build ID: f82ddfca21ebc1e222a662a32b25c0c9d20169ee
CPU threads: 8; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-US (en_PL.UTF-8); UI-Language: en-US
Calc: threaded

After downgrading from any recent version to this one, fonts are not blurred.
Comment 166 laurens 2020-02-13 11:28:20 UTC
For me the last one that is not blurry is 
Version: 6.2.7.1
Build ID: 23edc44b61b830b7d749943e020e96f5a7df63bf

on macOS 10.14.6

Note that there seems to be some rendering (==blurriness) differences between when using an external 2560x1440 monitor or just the internal 2880x1800 /2 (retina 1440x900 mode) screen - depending on whether the external monitor is connected when LO is started.

I don't know if that is a confounding factor in finding the root cause (and reproducibility) of this bug.

Note that using an external monitor causes the GFX to switch from Intel to external GPU due to the routing of USB-C Alt mode (DisplayPort over USB-C).
This will be different if the computer does not have a dedicated GPU.

For me version 6.2.8.x renders differently (== more blurry) than 6.2.7.1
Comment 167 Stephan Bergmann 2020-02-14 00:08:36 UTC
My blurriness check with my laptop being: start Calc, double click into cell A1, type "status" into the cell, hit return, "status" will either become blurry (bad) or be crisp (good).

Have Xcode 11.3.1 with SDK 10.15 and manually added /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.13.sdk copied from Xcode_9.4.xip obtained from <https://developer.apple.com/download/more/?=xcode%209.4>.

Comparing a crisp local master build with (among others)

  --with-macosx-sdk=10.13
  --with-macosx-version-max-allowed=10.13
  --with-macosx-version-min-required=10.13

against a blurry one with

  --with-macosx-sdk=10.15
  --with-macosx-version-max-allowed=10.13
  --with-macosx-version-min-required=10.13

(i.e., just switching the SDK used for the build), I find that what it takes to change the blurry build to be crisp is just the following:

In instdir/LibreOffice.app/Contents/MacOS/soffice change two bytes from 0f a0 to 00 00,

> --- soffice-blurry-hexl
> +++ soffice-fixed-hexl
> @@ -66,7 +66,7 @@
>  00000410: 0c00 0000 2f75 7372 2f6c 6962 2f64 796c  ..../usr/lib/dyl
>  00000420: 6400 0000 0000 0000 1b00 0000 1800 0000  d...............
>  00000430: 814c 6893 454b 30cd 9f65 d3ff c8f1 9cf2  .Lh.EK0..e......
> -00000440: 2400 0000 1000 0000 000d 0a00 000f 0a00  $...............
> +00000440: 2400 0000 1000 0000 000d 0a00 0000 0000  $...............
>  00000450: 2a00 0000 1000 0000 0000 0000 0000 0000  *...............
>  00000460: 2800 0080 1800 0000 100f 0000 0000 0000  (...............
>  00000470: 0000 0000 0000 0000 0c00 0000 5000 0000  ............P...

so that the LC_VERSION_MIN_MACOSX load command's sdk value changes from 10.15 to n/a,

> diff -u <(otool -l soffice-blurry) <(otool -l soffice-fixed)
> @@ -187,7 +187,7 @@
>        cmd LC_VERSION_MIN_MACOSX
>    cmdsize 16
>    version 10.13
> -      sdk 10.15
> +      sdk n/a
>  Load command 10
>        cmd LC_SOURCE_VERSION
>    cmdsize 16

Go figure.
Comment 168 Stephan Bergmann 2020-02-14 00:44:56 UTC
Potential "fix" at <https://gerrit.libreoffice.org/c/core/+/88667> "tdf#122218: Hack to avoid blurry text with macOS SDK 10.15"; lets see whether that helps for the TDF-provided builds.
Comment 169 Commit Notification 2020-02-14 07:14:35 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/645fe53be0dc36535dba0ed684e21ca4cda80d70

tdf#122218: Hack to avoid blurry text with macOS SDK 10.15

It will be available in 7.0.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 170 Nick 2020-02-14 08:29:52 UTC
> In instdir/LibreOffice.app/Contents/MacOS/soffice change two bytes from 0f
> a0 to 00 00,
> 
> > --- soffice-blurry-hexl
> > +++ soffice-fixed-hexl
> > @@ -66,7 +66,7 @@
> >  00000410: 0c00 0000 2f75 7372 2f6c 6962 2f64 796c  ..../usr/lib/dyl
> >  00000420: 6400 0000 0000 0000 1b00 0000 1800 0000  d...............
> >  00000430: 814c 6893 454b 30cd 9f65 d3ff c8f1 9cf2  .Lh.EK0..e......
> > -00000440: 2400 0000 1000 0000 000d 0a00 000f 0a00  $...............
> > +00000440: 2400 0000 1000 0000 000d 0a00 0000 0000  $...............
> >  00000450: 2a00 0000 1000 0000 0000 0000 0000 0000  *...............
> >  00000460: 2800 0080 1800 0000 100f 0000 0000 0000  (...............
> >  00000470: 0000 0000 0000 0000 0c00 0000 5000 0000  ............P...

I downloaded LibreOffice_6.4.1.1_MacOS_x86-64.dmg from libreoffice.org but (surprise, surprise) the fonts were blurry. Then I saw this revealing comment from Stephan Bergmann above. So I decided to give it a try and -- OH, MAGIC -- the fonts in Calc were SHARP!!

It's just two bytes to change in file "soffice" as described:

diff <(xxd soffice.touched) <(xxd soffice.original)
64c64
< 000003f0: 2400 0000 1000 0000 000a 0a00 0000 0000  $...............
---
> 000003f0: 2400 0000 1000 0000 000a 0a00 000e 0a00  $...............

I used Hex Fiend to do the job.

Make sure you first run LO at least once before touching the file or otherwise macOS will complain that the package cannot be validated. Steps:

1. Download LibreOffice_6.4.1.1_MacOS_x86-64.dmg from https://downloadarchive.documentfoundation.org/libreoffice/old/6.4.1.1/mac/x86_64/
2. Install
3. Run it once and Quit
4. cd /Applications/LibreOffice.app/Contents/MacOS
5. cp soffice ~/temp/soffice.original (create a backup copy in any folder you may like)
6. Edit soffice to zero the two bytes above, as shown in the diff
7. Save
8. Run LO and enjoy!

I'm a heavy Calc user and this issue has been bugging me for months as I had to stay with 6.2.8. Great job, Stephan -- thank you so much!! Hope we see your patch in the official releases soon!

I'm running macOS Mojave 10.14.6 on 13" MBP Retina.

Thanks
Comment 171 Emmeran Seehuber 2020-02-14 09:52:50 UTC
I can confirm that patching the SDK value in the soffice binary (6.4.1.1) as described by Nick and Stephan Bergmann works, i.e. the text is no longer blurry.

So macOS behaves differently depending on the SDK version it thinks an application is build with. I.e. some kind of compatibility mode vs the "current" behavior. I'll try to get some time to study the macOS 10.14 release notes. Maybe they even documented that change.
Comment 172 Emmeran Seehuber 2020-02-14 11:56:27 UTC
Apple has documented a behavior change depending on the linked SDK here:

https://developer.apple.com/documentation/macos_release_notes/macos_mojave_10_14_release_notes/appkit_release_notes_for_macos_10_14

Look for "Layer-Backed Views". From what I understand LibreOffice does not use "native" layers. But I might be just wrong. In that case this change might affect LibreOffice here.
Comment 173 Commit Notification 2020-02-14 16:31:15 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/b7fd89100d8653dc73955780358fe31d38b68ebf

tdf#122218: Baseline Xcode 9.3 ld presumably doesn't support -platform_version

It will be available in 7.0.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 174 Jan Iversen 2020-02-15 09:33:45 UTC
I can confirm, that the trick with the Hex-Editor also works with 6.4.0

Just changed the one byte in the file and the fonts are sharp now.

diff <(xxd soffice) <(xxd soffice.original)
64c64
< 000003f0: 2400 0000 1000 0000 000a 0a00 0000 0a00  $...............
---
> 000003f0: 2400 0000 1000 0000 000a 0a00 000e 0a00  $...............
Comment 175 Jan Iversen 2020-02-15 09:49:39 UTC
> It will be available in 7.0.0.
> 
> Affected users are encouraged to test the fix and report feedback.

I can confirm, that the Fonts are sharp in the current nightly-build.
Thanks for the patch :-)
Comment 176 Chris Shaw 2020-02-15 10:08:09 UTC
Confirmed fonts are sharp in nightly build

Version: 7.0.0.0.alpha0+
Build ID: 0cb4f304abf6f8dd6b40eb800788d2fe80581813
CPU threads: 4; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-GB (en_GB.UTF-8); UI-Language: en-US
Calc: threaded

on a Macbook Air 2018
Comment 177 Stephan Bergmann 2020-02-15 11:09:10 UTC
Verified with <https://dev-builds.libreoffice.org/daily/master/MacOSX-x86_64@tb81-TDF/2020-02-15_05.33.20/LibreOfficeDev_7.0.0.0.alpha0_MacOS_x86-64.dmg> at "Build ID: 0cb4f304abf6f8dd6b40eb800788d2fe80581813", thus containing both fixes from comment 169 and comment 173:  `otool -l LibreOfficeDev.app/Contents/MacOS/soffice | grep sdk` reports "sdk n/a" and my non-blurriness criterion from comment 167 is met.
Comment 178 bunkem 2020-02-15 15:35:25 UTC
Is there a chance this fix can be backported to the 6.4.x (i.e. current release) before LO turns off too many users?

Some of us aren't so technically savvy so don't know how to apply this fix ourselves.  And the vast majority of users will not do the fix.  We'll leave too many people behind or turn them off of LO.  That would be a terrible shame.
Comment 179 Commit Notification 2020-02-15 16:54:24 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "libreoffice-6-4":

https://git.libreoffice.org/core/commit/ec9f0161d9b5a57d4b8e3e17150fabcc6e4c67a1

tdf#122218: Hack to avoid blurry text with macOS SDK 10.15

It will be available in 6.4.2.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 180 Commit Notification 2020-02-15 16:54:50 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "libreoffice-6-3":

https://git.libreoffice.org/core/commit/1896b9cf0011b0f2f453d8123141ab24957b8947

tdf#122218: Hack to avoid blurry text with macOS SDK 10.15

It will be available in 6.3.6.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 181 Nick 2020-02-17 13:44:35 UTC
(In reply to bunkem from comment #178)
> Is there a chance this fix can be backported to the 6.4.x (i.e. current
> release) before LO turns off too many users?
> 
> Some of us aren't so technically savvy so don't know how to apply this fix
> ourselves.  And the vast majority of users will not do the fix.  We'll leave
> too many people behind or turn them off of LO.  That would be a terrible
> shame.

While waiting for the new fixed versions to come out, for those less technical and who don't have a hex editor at hand, you can do this at Step 6 in my patch instructions above (comment 170):

xxd ~/temp/soffice.original | sed 's/000003f0: 2400 0000 1000 0000 000a 0a00 000e 0a00/000003f0: 2400 0000 1000 0000 000a 0a00 0000 0000/' | xxd -r >soffice

To check, run:
diff <(xxd ~/temp/soffice.original) <(xxd soffice)

You should see the diff output from my comment.

Hope this helps.

Thanks
Comment 182 Wim M 2020-02-17 14:24:54 UTC
I patched the current release (6.4.0.3) successfully with a hex editor by looking for the right string as described in the comments above. Note that the bytes to be zeroed are 0e 0a. 

diff <(xxd soffice.original) <(xxd soffice) 
64c64
< 000003f0: 2400 0000 1000 0000 000a 0a00 000e 0a00  $...............
---
> 000003f0: 2400 0000 1000 0000 000a 0a00 0000 0000  $...............

I did it just before comment #181 appeared so that would have made it even easier.

Thanks to everyone who has contributed to solving this, especially Stephan and Nick.
Comment 183 Commit Notification 2020-02-17 14:46:17 UTC
Stephan Bergmann committed a patch related to this issue.
It has been pushed to "libreoffice-6-4-1":

https://git.libreoffice.org/core/commit/1756130377524734cbc22927176e6de1cd5f8f91

tdf#122218: Hack to avoid blurry text with macOS SDK 10.15

It will be available in 6.4.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 184 Xisco Faulí 2020-02-17 15:43:36 UTC
For those having this issue: can you verify that https://dev-builds.libreoffice.org/macosx-debug/minsdktweak/LibreOffice_6.3.5.2_MacOS_x86-64.dmg fixes the font-issue on mac (a build with sberg's fix done on top of the 6.3.5.2 tag)
Comment 185 laurens 2020-02-17 17:29:13 UTC
(In reply to Commit Notification from comment #183)
> Stephan Bergmann committed a patch related to this issue.
> It has been pushed to "libreoffice-6-4-1":
> 
> https://git.libreoffice.org/core/commit/
> 1756130377524734cbc22927176e6de1cd5f8f91
> 
> tdf#122218: Hack to avoid blurry text with macOS SDK 10.15
> 
> It will be available in 6.4.1.
> 
> The patch should be included in the daily builds available at
> https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
> information about daily builds can be found at:
> https://wiki.documentfoundation.org/Testing_Daily_Builds
> 
> Affected users are encouraged to test the fix and report feedback.

Already a good improvement, but I would like to reopen

Applied the Comment 170 fix - to 
Version: 6.4.1.1
Build ID: 56f3c78975db08733f771c53643b5d1aa7c57567
CPU threads: 12; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: nb-NO (en_NO.UTF-8); UI-Language: en-US
Calc: threaded

It's not completely fixed: if you have an external monitor attached (in this case a 2560x1440 monitor) and it is set as the main screen (Settings-> Displays -> Arrangement -> Menu bar) when you start LO (with the patch) then the fonts remain blurred on the Mac's screen, until the external monitor is disconnected and LO is restarted or the screen arrangement (main screen menu bar) is changed *and* LO is maximised on the Mac's screen.
Comment 186 Xisco Faulí 2020-02-17 17:32:21 UTC
(In reply to laurens from comment #185)
> (In reply to Commit Notification from comment #183)
> > Stephan Bergmann committed a patch related to this issue.
> > It has been pushed to "libreoffice-6-4-1":
> > 
> > https://git.libreoffice.org/core/commit/
> > 1756130377524734cbc22927176e6de1cd5f8f91
> > 
> > tdf#122218: Hack to avoid blurry text with macOS SDK 10.15
> > 
> > It will be available in 6.4.1.
> > 
> > The patch should be included in the daily builds available at
> > https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
> > information about daily builds can be found at:
> > https://wiki.documentfoundation.org/Testing_Daily_Builds
> > 
> > Affected users are encouraged to test the fix and report feedback.
> 
> Already a good improvement, but I would like to reopen
> 
> Applied the Comment 170 fix - to 
> Version: 6.4.1.1
> Build ID: 56f3c78975db08733f771c53643b5d1aa7c57567
> CPU threads: 12; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
> Locale: nb-NO (en_NO.UTF-8); UI-Language: en-US
> Calc: threaded
> 
> It's not completely fixed: if you have an external monitor attached (in this
> case a 2560x1440 monitor) and it is set as the main screen (Settings->
> Displays -> Arrangement -> Menu bar) when you start LO (with the patch) then
> the fonts remain blurred on the Mac's screen, until the external monitor is
> disconnected and LO is restarted or the screen arrangement (main screen menu
> bar) is changed *and* LO is maximised on the Mac's screen.

Please, create a follow-up report -> https://bugs.documentfoundation.org/enter_bug.cgi?product=LibreOffice&format=guided
Comment 187 eisa01 2020-02-17 20:36:43 UTC
(In reply to laurens from comment #185)
> It's not completely fixed: if you have an external monitor attached (in this
> case a 2560x1440 monitor) and it is set as the main screen (Settings->
> Displays -> Arrangement -> Menu bar) when you start LO (with the patch) then
> the fonts remain blurred on the Mac's screen, until the external monitor is
> disconnected and LO is restarted or the screen arrangement (main screen menu
> bar) is changed *and* LO is maximised on the Mac's screen.

This may be bug #85499 or bug #108801, or a variation thereof
Comment 188 eisa01 2020-02-17 20:57:22 UTC
(In reply to Xisco Faulí from comment #184)
> For those having this issue: can you verify that
> https://dev-builds.libreoffice.org/macosx-debug/minsdktweak/LibreOffice_6.3.
> 5.2_MacOS_x86-64.dmg fixes the font-issue on mac (a build with sberg's fix
> done on top of the 6.3.5.2 tag)

This build is NOT sharp for me. Can someone else double check?

Version: 6.3.5.2
Build ID: 27376e88532224e634cad187bf3095a7faa73fc9
CPU threads: 4; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-US (en_US.UTF-8); UI-Language: en-US
Calc: threaded

However, the first nightly build with the fix was sharp for me
Version: 7.0.0.0.alpha0+
Build ID: 0cb4f304abf6f8dd6b40eb800788d2fe80581813
CPU threads: 4; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-US (en_US.UTF-8); UI-Language: en-US
Calc: threaded
Comment 189 Emmeran Seehuber 2020-02-18 08:09:41 UTC
(In reply to eisa01 from comment #188)
> (In reply to Xisco Faulí from comment #184)
> > For those having this issue: can you verify that
> > https://dev-builds.libreoffice.org/macosx-debug/minsdktweak/LibreOffice_6.3.
> > 5.2_MacOS_x86-64.dmg fixes the font-issue on mac (a build with sberg's fix
> > done on top of the 6.3.5.2 tag)
> 
> This build is NOT sharp for me. Can someone else double check?
> 
This build is also not sharp for me. 

otool -l tells me:

Load command 9
      cmd LC_VERSION_MIN_MACOSX
  cmdsize 16
  version 10.10
      sdk 10.14

So the "hack fix" was not applied on this build.
Comment 190 Stephan Bergmann 2020-02-18 08:28:44 UTC
(In reply to Xisco Faulí from comment #184)
> For those having this issue: can you verify that
> https://dev-builds.libreoffice.org/macosx-debug/minsdktweak/LibreOffice_6.3.
> 5.2_MacOS_x86-64.dmg fixes the font-issue on mac (a build with sberg's fix
> done on top of the 6.3.5.2 tag)

With what version of Xcode (and on what version of macOS, and with what --with-macosx-sdk, --with-macosx-version-min-required, and --with-macosx-version-max-allowed) was that built?

My understanding regarding my patch <https://gerrit.libreoffice.org/c/core/+/88698> "tdf#122218: Hack to avoid blurry text with macOS SDK 10.15" is as follows:

* When building against the baseline Xcode 9.3, the patch should not be necessary.  The patch will effectively not do anything (because that Xcode's ld does not yet support -platform_version), but the linked soffice executable as-is should not contain a LC_VERSION_MIN_MACOSX load command with a problematic sdk value.  Text should be crisp.

* When building against current Xcode 11, the patch should kick in (because that Xcode's ld supports -platform_version) and fix up the sdk value of the soffice executable's LC_VERSION_MIN_MACOSX load command.  Text should be crips.

* When building against some interim Xcode (like Xcode 10), the patch will likely not kick in, but the linked soffice executable as-is might contain a LC_VERSION_MIN_MACOSX load command with a problematic sdk value.  Text could be blurry.

(My naive assumption was that all official TDF builds would be done with Xcode 11.)
Comment 191 Stephan Bergmann 2020-02-18 09:02:03 UTC
(In reply to Stephan Bergmann from comment #190)
> (In reply to Xisco Faulí from comment #184)
> > For those having this issue: can you verify that
> > https://dev-builds.libreoffice.org/macosx-debug/minsdktweak/LibreOffice_6.3.
> > 5.2_MacOS_x86-64.dmg fixes the font-issue on mac (a build with sberg's fix
> > done on top of the 6.3.5.2 tag)
> 
> With what version of Xcode (and on what version of macOS, and with what
> --with-macosx-sdk, --with-macosx-version-min-required, and
> --with-macosx-version-max-allowed) was that built?

On IRC, cloph confirmed that that build was done with "xcode 10 on macos 10.13".  So that would match my understanding that such a build will be blurry.
Comment 192 Stephan Bergmann 2020-02-18 09:50:49 UTC
So my understanding regarding the "official" TDF builds for macOS (that show up at <https://www.libreoffice.org/download/download/>) is as follows (and please anybody in the know correct me if I'm wrong):

* The following pertains to all current and future builds of LO 6.3 and 6.4 (and potentially also to future builds of LO 7.0?).

* The builds are not done with the baseline Xcode 9.3 because of notarization issues.

* The builds are not done with current Xcode 11 because that requires at least macOS 10.14.4, and the build machines run macOS 10.13 (see next).

* I do not know the reason why the build machines run macOS 10.13 rather than 10.14.

* The builds are therefore done with Xcode 10.  As discussed in comment 190, this leads to blurry builds.

* This means that all the future LO 6.3. and 6.4 (and potentially also 7.0?) "official" TDF builds will remain blurry.

(Only the Gerrit Jenkins builds and those provided under "Nightly Builds" at <https://www.libreoffice.org/download/pre-releases/> appear to be done with Xcode 11; see also <https://lists.freedesktop.org/archives/libreoffice/2020-February/084471.html> "Bump macOS Xcode baseline to 11?".)

I see two ways how to make the "official" TDF builds non-blurry:

* Either do them with current Xcode 11 on macOS >= 10.14.4.

* Or create a fix that, for builds using Xcode 10, post-processes the soffice executable along the lines of the xxd/sed invocation from comment 181.
Comment 193 Mike Kaganski 2020-02-18 09:56:39 UTC
(In reply to Stephan Bergmann from comment #192)

... or explicitly use SDK 10.13 (like in https://gerrit.libreoffice.org/c/core/+/86218) using the config switch?
Comment 194 Stephan Bergmann 2020-02-18 10:11:03 UTC
(In reply to Mike Kaganski from comment #193)
> (In reply to Stephan Bergmann from comment #192)
> 
> ... or explicitly use SDK 10.13 (like in
> https://gerrit.libreoffice.org/c/core/+/86218) using the config switch?

...which would presumably mean that support for MacOSX10.13.sdk would need to manually be added to the Xcode 10 installations on those build machines, assuming Xcode 10 only comes with support for MacOSX10.14.sdk.  (See the "Have Xcode 11.3.1 with SDK 10.15 and manually added..." paragraph of comment 167 for that manual addition.)

But even then, I'm not sure whether the resulting builds would be blurry or not.  My assumption is that the ld from Xcode 10 would generate an soffice executable with an LC_VERSION_MIN_MACOSX load command that has an sdk value of 10.13, rather than the n/a (aka 0.0.0) value that we know causes crisp results.  (Where that sdk n/a value is caused by Clang <https://github.com/llvm/llvm-project/commit/25ce33a6e4f3b13732c0f851e68390dc2acb9123> "[driver][darwin] Pass -platform_version flag to the linker instead of the -<platform>_version_min
flag", but only in combination with an ld that supports -platform_version, which the ld from Xcode 10 apparently does not.)
Comment 195 Stephan Bergmann 2020-02-18 10:13:22 UTC
(In reply to Stephan Bergmann from comment #194)
> But even then, I'm not sure whether the resulting builds would be blurry or
> not.  My assumption is that the ld from Xcode 10 would generate an soffice
> executable with an LC_VERSION_MIN_MACOSX load command that has an sdk value
> of 10.13, rather than the n/a (aka 0.0.0) value that we know causes crisp
> results.  (Where that sdk n/a value is caused by Clang
> <https://github.com/llvm/llvm-project/commit/
> 25ce33a6e4f3b13732c0f851e68390dc2acb9123> "[driver][darwin] Pass
> -platform_version flag to the linker instead of the -<platform>_version_min
> flag", but only in combination with an ld that supports -platform_version,
> which the ld from Xcode 10 apparently does not.)

(...and where the Clang from Xcode 10 presumably doesn't even have that "[driver][darwin] Pass -platform_version flag to the linker instead of the -<platform>_version_min flag" patch yet, to begin with)
Comment 196 Stephan Bergmann 2020-02-18 11:42:54 UTC
Reopened based on comment 192: "This means that all the future LO 6.3. and 6.4 (and potentially also 7.0?) 'official' TDF builds will remain blurry."  (See there for potential ways how to fix.)
Comment 197 Nick 2020-02-18 13:34:36 UTC
(In reply to Stephan Bergmann from comment #191)
> > With what version of Xcode (and on what version of macOS, and with what
> > --with-macosx-sdk, --with-macosx-version-min-required, and
> > --with-macosx-version-max-allowed) was that built?
> 
> On IRC, cloph confirmed that that build was done with "xcode 10 on macos
> 10.13".  So that would match my understanding that such a build will be
> blurry.

I wonder why such an old version of macOS is used for build environment. MacOS 10.13 High Sierra was released on September 25, 2017 which makes it about 2.5 years old. It's currently used by 15.88% of users, according to Statcounter GlobalStats.

This bug appeared in official builds with LO 6.3.0.1 dated 07-Jul-2019, if I'm not wrong. So it has been 7.5 months and probably tens of thousands of Mac downloads, resulting in many thousands of frustrated ordinary users. I cannot help but think how many hours of suffering this has caused.

Now that we know how it can be fixed, I sincerely hope that somebody at LO takes the issue to heart.

Thank you, Stephan!
Comment 198 Stephan Bergmann 2020-02-20 15:56:30 UTC
Two relevant quotes from <https://lists.freedesktop.org/archives/libreoffice/2020-February/084519.html> "ESC meeting minutes: 2020-02-20":

> + 6.4.2 would be built with xcode11 on macOS (Mojave/10.14)

> + Still, my fix only fixes the symptoms with Xcode 11 (and who knows
>   what bad side effects it could eventually have), not the
>   underlying cause (whatever that is exactly, probably related to
>   "Layer-Backed Views",
>   <https://bugs.documentfoundation.org/show_bug.cgi?id=122218#c172>)
>   which should still be fixed. (Stephan)
Comment 199 Stephan Bergmann 2020-02-21 16:20:56 UTC
(In reply to Stephan Bergmann from comment #198)
> Two relevant quotes from
> <https://lists.freedesktop.org/archives/libreoffice/2020-February/084519.
> html> "ESC meeting minutes: 2020-02-20":
> 
> > + 6.4.2 would be built with xcode11 on macOS (Mojave/10.14)

Based on that, lets set tentatively back to FIXED with "target:7.0.0 target:6.4.2", and see what the actual artefacts produced by TDF for those releases will be.

(At least for LO master towards LO 7.0, <https://gerrit.libreoffice.org/plugins/gitiles/core/+/358146bbbd1b9775c12770fb5e497b6ec5adfc51%5E!/> "Bump macOS build baseline to Xcode 11.3 and macOS 10.14.4" now requires that the build will be done with "known good" Xcode >= 11, anyway.)

> > + Still, my fix only fixes the symptoms with Xcode 11 (and who knows
> >   what bad side effects it could eventually have), not the
> >   underlying cause (whatever that is exactly, probably related to
> >   "Layer-Backed Views",
> >   <https://bugs.documentfoundation.org/show_bug.cgi?id=122218#c172>)
> >   which should still be fixed. (Stephan)

^ This is still very relevant!  Anybody knowledgeable about the involved macOS APIs and LO's vcl code, please go ahead. :)
Comment 200 eisa01 2020-02-24 20:41:16 UTC
*** Bug 130889 has been marked as a duplicate of this bug. ***
Comment 201 mr.viennavienna 2020-02-27 13:17:34 UTC Comment hidden (no-value)
Comment 202 Stephan Bergmann 2020-02-27 13:21:02 UTC
(In reply to mr.viennavienna from comment #201)
> 6.4.1 has blurred fonts

...as expected, see comment 199
Comment 203 José Luís Andrade 2020-02-28 16:28:54 UTC
1 - Download Hex Fiend application
https://ridiculousfish.com/hexfiend/

2 - Download Libreoffice 6.4.1
https://www.libreoffice.org/download/download/

3 - Open the soffice file with Hex Fiend application
LibreOffice.app/Contents/MacOS/soffice

4 - Edit soffice

Original
000003f0: 2400 0000 1000 0000 000a 0a00 000e 0a00

Modified
000003f0: 2400 0000 1000 0000 000a 0a00 0000 0000

With this steps I have the Libreoffice sharp.
Comment 204 Commit Notification 2020-02-28 18:42:47 UTC
Christian Lohmaier committed a patch related to this issue.
It has been pushed to "libreoffice-6-4":

https://git.libreoffice.org/core/commit/4b0dac479ac3ddfc206fe98d66a2d41cc6559c5d

tdf#122218 TDF builds for 6.4 are now done on Mojave with Xcode 11

It will be available in 6.4.2.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 205 Frank Fuchs 2020-03-01 16:26:56 UTC Comment hidden (no-value)
Comment 206 Frank Fuchs 2020-03-01 16:28:49 UTC Comment hidden (obsolete)
Comment 207 chaplinsociety 2020-03-05 09:16:42 UTC Comment hidden (spam)
Comment 208 war 2020-03-09 08:13:23 UTC
(In reply to Frank Fuchs from comment #205)
> LibO 6.4.2.1 shows sharp fonts on my macOS 10.15.3 machine, whereas the
> previous (unpatched) versions showed blurry fonts.
> Learning from this, I guess it makes sense to keep the macOS build
> environment up-to-date :-)

In this case I would recommend using Catalina (10.15.3) and XCode 13 (Mojave and XCode 11 are outdated)
Comment 209 Daniel 2020-03-14 08:58:12 UTC
(In reply to Commit Notification from comment #204)
> Affected users are encouraged to test the fix and report feedback.

I just tried version 7.0.0.0.alpha0+. The blurry fonts are gone on macOS 10.15.3 (Catalina). Thanks!

Though I still have pixelated icons in the toolbars. For some reason, SVG with and without anti-aliasing looks even worse than non-SVG.
Comment 210 Spood 2020-03-19 20:43:35 UTC
Version: 6.4.2.2
Build ID: 4e471d8c02c9c90f512f7f9ead8875b57fcb1ec3
CPU threads: 4; OS: Mac OS X 10.14.6; UI render: default; VCL: osx; 
Locale: en-AU (en_AU.UTF-8); UI-Language: en-US
Calc: threaded

Fonts now appear as sharp/similar to those on Word and FreeOffice
Comment 211 Spood 2020-03-19 20:48:16 UTC
Created attachment 158822 [details]
Blurred Font Comparison V6.4.1.2

A comparison view with same font of LO 6.4.1.2 to Word and FreeOffice
Comment 212 Spood 2020-03-19 20:49:59 UTC
Created attachment 158823 [details]
Blurred Font Comparison V6.4.2.2

A comparison with same font on LO 6.4.2.2 to Word and FreeOffice
Comment 213 bunkem 2020-03-20 15:01:19 UTC
I agree that 6.4.2.2 looks OK now.

Can I suggest that the fix be included in the README or What's Changed for this version?  This way it will be noted in the documentation.

B.
Comment 214 info 2020-04-15 09:39:37 UTC
This "fix" does not work if you have a non-retina monitor connected to a Retina Macbook Pro - depending on the order of opening LO, and which screen is set to "main"
Comment 215 Stephan Bergmann 2020-04-15 09:42:31 UTC
(In reply to info from comment #214)
> This "fix" does not work if you have a non-retina monitor connected to a
> Retina Macbook Pro - depending on the order of opening LO, and which screen
> is set to "main"

See the "See Also" section, issue 108801 and issue 85499.
Comment 216 V Stuart Foote 2020-04-24 16:13:48 UTC
*** Bug 132382 has been marked as a duplicate of this bug. ***
Comment 217 V Stuart Foote 2020-04-24 16:15:01 UTC
*** Bug 127020 has been marked as a duplicate of this bug. ***
Comment 218 V Stuart Foote 2020-05-01 01:51:11 UTC
*** Bug 132560 has been marked as a duplicate of this bug. ***
Comment 219 Tor Lillqvist 2020-05-01 15:59:24 UTC
Created attachment 160184 [details]
Diff with experimentation

I spent a couple of days trying changing various settings to see if I can come up text that loks as crisp as with the current workaround, but nope. FYI, here is how I hacked on it. Setting environment variables RASTERIZE, SCALE, DONTTOUCH, ALLOWAA, SHOULDAA, ALLOWSMOOTH etc (see the diff) when running instdir/LibreOfficeDev.app/Contents/MacOS/soffice you can see what changes, if anything.

I also wrote a small macOS app where you can interactively toggle and tune the settings and see how if affects rendered text. It is a bit WIP still, but if somebody feels like carrying on hacking on that, feel free to ask me for the sources.

The CGContextSetFontSmoothingStyle() and CGContextSetFontSmoothingContrast() are undocumented, but I saw them mentioned on the net. Tweaking them doesn't seem to have much impact, though.
Comment 220 Tor Lillqvist 2020-05-02 19:44:28 UTC
Created attachment 160238 [details]
Screenshot of LO with workaround and without on non-Retina

On a non-Retina the problem is not present, as indeed expected based on what the bug says. Text in a LO with the platform_version workaround (to the left) and without (to the right) look the same.
Comment 221 Tor Lillqvist 2020-05-02 19:48:29 UTC
Created attachment 160239 [details]
Screenshot of LO with workaround and without on Retina display

And on a Retina display, one can see that in the LO with the workaround, the text is rendered at the physical pixel resolution, while in the LO without the workaround it apparently is rendered at the "logical" pixel resolution (half of the physical resolution) but then scaled with "helpful" interpolation to the physical resolution.
Comment 222 Tor Lillqvist 2020-05-02 19:50:22 UTC
(But my screenshots and comments above probably just repeats what everybody who has looked into this already knew; just wanted to make it clear to myself.)